
TYPO3.Fluid - Bug # 29290

Status: Resolved Priority: Must have
Author: Torsten no-lastname-given Category: ViewHelpers
Created: 2011-08-26 Assigned To: Bastian Waidelich
Updated: 2013-09-26 Due date:
Has patch: Yes
Affected Flow version: FLOW3 1.0.0
Subject: Additional Identity Properties not set on mapping error
Description

After a mapping error occurred, no additional identity properties are set and FLOW3 tries to create a new object.

Could be easily fixed in TYPO3\Fluid\ViewHelpers\Form\AbstractFormFieldViewHelper

currently:

    protected function getValue() {
        $value = NULL;

        if ($this->arguments->hasArgument('value')) {
            $value = $this->arguments['value'];
        } elseif ($this->hasMappingErrorOccured()) {
            $value = $this->getLastSubmittedFormData();
        } elseif ($this->isObjectAccessorMode() &&
$this->viewHelperVariableContainer->exists('TYPO3\Fluid\ViewHelpers\FormViewHelper', 'formObject')) {
            $this->addAdditionalIdentityPropertiesIfNeeded();
            $value = $this->getPropertyValue();
        }
        if (is_object($value)) {
            $identifier = $this->persistenceManager->getIdentifierByObject($value);
            if ($identifier !== NULL) {
                $value = $identifier;
            }
        }
        return $value;
    }

Better:

    protected function getValue() {
        $value = NULL;

        if ($this->arguments->hasArgument('value')) {
            $value = $this->arguments['value'];
        } elseif ($this->hasMappingErrorOccured()) {
            $this->addAdditionalIdentityPropertiesIfNeeded();
            $value = $this->getLastSubmittedFormData();
        } elseif ($this->isObjectAccessorMode() &&
$this->viewHelperVariableContainer->exists('TYPO3\Fluid\ViewHelpers\FormViewHelper', 'formObject')) {
            $this->addAdditionalIdentityPropertiesIfNeeded();
            $value = $this->getPropertyValue();
        }
        if (is_object($value)) {
            $identifier = $this->persistenceManager->getIdentifierByObject($value);
            if ($identifier !== NULL) {
                $value = $identifier;
            }
        }
        return $value;
    }

Related issues:
related to Core - Bug # 59253: Additional Identity Properties not set on mapp... Resolved 2014-06-01
duplicated by TYPO3.Fluid - Bug # 46038: Subproperty with Radio fields doesn'... Closed 2013-03-05
duplicated by TYPO3.Fluid - Bug # 33274: Viewhelpers extending AbstractFormFi... Closed 2012-01-18

Associated revisions
Revision 3a56759e - 2013-09-24 18:23 - Alexander Berl

[BUGFIX] Additional Identity Properties not set on mapping error

When binding Fluid forms to nested objects, Fluid automatically adds
hidden fields with the identifiers of all affected objects so that
the persistence layer can update all objects correctly.

When a form was redisplayed due to property mapping errors, the
identity fields for the nested sub objects were no longer created.

This change fixes this by making sure all identity fields are rendered
recursively also after property mapping errors.

Example code to verify this::
&lt;f:form action="update" object="{user}" objectName="user"&gt;
      &lt;f:form.textfield property="firstName" /&gt;
      &lt;f:for each="{user.invoices}" as="invoice" iteration="iteration"&gt;
    {iteration.cycle}:
        &lt;f:form.textfield property="invoices.{iteration.index}.subject" /&gt;
      &lt;/f:for&gt;
      &lt;f:form.submit value="update" /&gt;
    &lt;/f:form&gt;

When submitting the form with validation errors, the redisplayed form
should contain a div with a hidden field named
"user[__identity]" for the user and one for each invoice.

Change-Id: I3debbc135d31278e91b83b3ac375bd5f62d13923
Fixes: #29290
Releases: master, 2.0
Revision 516fc370 - 2013-09-26 16:09 - Alexander Berl

[BUGFIX] Additional Identity Properties not set on mapping error

When binding Fluid forms to nested objects, Fluid automatically adds
hidden fields with the identifiers of all affected objects so that
the persistence layer can update all objects correctly.

When a form was redisplayed due to property mapping errors, the
identity fields for the nested sub objects were no longer created.

This change fixes this by making sure all identity fields are rendered
recursively also after property mapping errors.

Example code to verify this::
&lt;f:form action="update" object="{user}" objectName="user"&gt;
      &lt;f:form.textfield property="firstName" /&gt;
      &lt;f:for each="{user.invoices}" as="invoice" iteration="iteration"&gt;
    {iteration.cycle}:
        &lt;f:form.textfield property="invoices.{iteration.index}.subject" /&gt;
      &lt;/f:for&gt;
      &lt;f:form.submit value="update" /&gt;
    &lt;/f:form&gt;

When submitting the form with validation errors, the redisplayed form
should contain a div with a hidden field named
"user[__identity]" for the user and one for each invoice.

Change-Id: I3debbc135d31278e91b83b3ac375bd5f62d13923
Fixes: #29290
Releases: master, 2.0

Revision b0740818 - 2013-10-07 16:10 - Bastian Waidelich

[BUGFIX] Form ViewHelpers throw exception if no formObject is set

When using forms with object binding Fluid throws an exception for FormField
ViewHelpers bound to nested properties if no form object is available.
This is the case for example in newAction() where the object is usually NULL::

&lt;f:form action="create" objectName="user"&gt;
      &lt;f:form.textfield property="name.firstName" /&gt;
    &lt;/f:form&gt;

Change-Id: I3b0af1667e45c9e5cbe56b5bca69d717ba206320
Related: #29290
Releases: master, 2.0

Revision 695cb813 - 2014-02-19 11:42 - Bastian Waidelich

[BUGFIX] Form ViewHelpers throw exception if no formObject is set
When using forms with object binding Fluid throws an exception for FormField
ViewHelpers bound to nested properties if no form object is available.
This is the case for example in newAction() where the object is usually NULL::

&lt;f:form action="create" objectName="user"&gt;
      &lt;f:form.textfield property="name.firstName" /&gt;
    &lt;/f:form&gt;

Change-Id: I3b0af1667e45c9e5cbe56b5bca69d717ba206320
Related: #29290
Releases: master, 2.0

History
#1 - 2011-10-21 13:37 - Karsten Dambekalns
- Affected Flow version set to FLOW3 1.0.0

#2 - 2012-01-31 21:16 - Bastian Waidelich
- Status changed from New to Accepted
- Assigned To set to Bastian Waidelich

#3 - 2012-08-11 19:55 - Gerrit Code Review
- Status changed from Accepted to Under Review

Patch set 1 for branch master has been pushed to the review server.
It is available at http://review.typo3.org/13600

#4 - 2012-08-12 11:22 - Gerrit Code Review

Patch set 2 for branch master has been pushed to the review server.
It is available at http://review.typo3.org/13600

#5 - 2012-08-14 00:16 - Gerrit Code Review

Patch set 3 for branch master has been pushed to the review server.
It is available at http://review.typo3.org/13600

#6 - 2012-09-03 14:15 - Gerrit Code Review

Patch set 4 for branch master has been pushed to the review server.
It is available at http://review.typo3.org/13600

#7 - 2012-11-20 17:47 - Gerrit Code Review

Patch set 5 for branch master has been pushed to the review server.
It is available at http://review.typo3.org/13600

#8 - 2013-03-26 19:05 - Gerrit Code Review
Patch set 6 for branch master has been pushed to the review server.
It is available at https://review.typo3.org/13600

#9 - 2013-03-27 12:25 - Gerrit Code Review

Patch set 7 for branch master has been pushed to the review server.
It is available at https://review.typo3.org/13600

#10 - 2013-09-24 17:10 - Gerrit Code Review

Patch set 8 for branch master has been pushed to the review server.
It is available at https://review.typo3.org/13600

#11 - 2013-09-24 17:35 - Gerrit Code Review

Patch set 9 for branch master has been pushed to the review server.
It is available at https://review.typo3.org/13600

#12 - 2013-09-24 18:23 - Gerrit Code Review

Patch set 10 for branch master has been pushed to the review server.
It is available at https://review.typo3.org/13600

#13 - 2013-09-26 16:07 - Gerrit Code Review

Patch set 1 for branch 2.0 has been pushed to the review server.
It is available at https://review.typo3.org/24068

#14 - 2013-09-26 16:09 - Gerrit Code Review

Patch set 2 for branch 2.0 has been pushed to the review server.
It is available at https://review.typo3.org/24068

#15 - 2013-09-26 16:36 - Alexander Berl
- Status changed from Under Review to Resolved
- % Done changed from 0 to 100

Applied in changeset commit:3a56759eb8548783d540dd757b24cfa6c244c46b.
